#ifndef PIX_H
#define PIX_H

#define level_width_max 20
#define level_height_max 20

#include <qwidget.h>
#include <qpixmap.h>
#include <qrect.h>
#include <stdio.h>
#include <qapplication.h>
#include <qpainter.h>
#include <kglobal.h>
#include <kstddirs.h>
#include <kconfig.h>

class Block : public QWidget
{
	Q_OBJECT
public:
		Block( QWidget *parent=0, const char *name=0 );
		int x1, x2;
		int level[level_width_max][level_height_max], exit_position[2];
		int backuplevel[level_width_max][level_height_max], start_position[2];
		int level_width, level_height, teleport_position[2][2];
		int x, y;
		bool firstMove;
		QPixmap pm0;
		QPixmap pm0l1r;
		QPixmap pm0l2r;
		QPixmap pm0l3r;
		QPixmap pm0r1l;
		QPixmap pm0r2l;
		QPixmap pm0r3l;
		QPixmap pm0t1b;
		QPixmap pm0t2b;
		QPixmap pm0t3b;
		QPixmap pm0b1t;
		QPixmap pm0b2t;
		QPixmap pm0b3t;
		QPixmap pm2;
		QPixmap pm25; // main character inside a teleport (2 in 5)
		QPixmap pmlkr; // main character, going from left -> right
		QPixmap pmrkl;
		QPixmap pmbkt;
		QPixmap pmtkb; // main character, going from top -> bottom
		QPixmap pm3;
		QPixmap pm5;
		QPixmap pm9;
		QPixmap pm10;
		QPixmap pm11;
		QPixmap pmt1, pmt2, pmt3, pmt4, pmt5, pmt6; // teleport anim
		QPixmap pme1, pme2, pme3, pme4, pme5, pme6, pme7, pme8, pme9, pme10; // exit anim

		void paintEvent( QPaintEvent * );
protected:
};

#endif // PIX_H
